SystemOrganization addCategory: #ConfigurationOfGemTools!

Object subclass: #ConfigurationOfGemTools
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfGemTools'!

!ConfigurationOfGemTools class methodsFor: 'private' stamp: 'dkh 12/8/2009 10:56'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfGemTools class methodsFor: 'private' stamp: 'dkh 1/4/2010 11:03'!
ensureMetacello
        "Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
        version of Metacello itself."

        Smalltalk at: #MetacelloProject ifAbsent: [
                Smalltalk at: #Gofer ifAbsent: [
                        "Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
                        self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
                Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
                        gofer := goferClass new
                                url: 'http://seaside.gemstone.com/ss/metacello';
                                yourself.
                        [ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
                        gofer load ].
                "load latest version of Metacello, load a specific version if desired"
                (Smalltalk at: #ConfigurationOfMetacello) perform: #load ]

! !

!ConfigurationOfGemTools class methodsFor: 'metacello tool support' stamp: 'dkh 12/8/2009 10:56'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^self name ~= #GemToolsCommonConfiguration! !

!ConfigurationOfGemTools class methodsFor: 'loading' stamp: 'dkh 1/11/2010 11:53'!
load
	"self load"
	
	^self project latestVersion load! !

!ConfigurationOfGemTools class methodsFor: 'loading' stamp: 'dkh 1/11/2010 11:54'!
loadLatestVersion
	"self loadLatestVersion"
	
	self project updateProject.
	^self load! !

!ConfigurationOfGemTools class methodsFor: 'accessing' stamp: 'dkh 12/8/2009 10:55'!
project

	^self new project! !

!ConfigurationOfGemTools methodsFor: 'baselines' stamp: 'DaleHenrichs 2/23/2010 16:13'!
baseline10beta0: spec 
	<version: '1.0-beta.0-baseline'>
	
	spec for: #squeakCommon do: [
		spec blessing: #baseline.
		spec description: 'Baseline GemTools client for Pharo/Squeak. Loads bleeding edge code.'.
		spec repository: 'http://seaside.gemstone.com/ss/GLASSClient'.
		spec
			project: 'FFI' with: [
				spec
					className: 'ConfigurationOfFFI';
					versionString: '1.2';
					file: 'ConfigurationOfFFI';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].

		spec 
			package: 'OB-SUnitGUI' with: [
				spec repository: 'http://seaside.gemstone.com/ss/obsunit' ];
			package: 'GemTools-Client' with: [
				spec requires: { 'FFI'. 'OB-SUnitGUI'. } ];
			package: 'GemTools-Platform' with: [
				spec requires: { 'GemTools-Client'. } ]].
! !

!ConfigurationOfGemTools methodsFor: 'baselines' stamp: 'DaleHenrichs 2/16/2010 20:45'!
baseline10beta3: spec 
	<version: '1.0-beta.3-baseline'>
	
	spec for: #squeakCommon do: [
		spec blessing: #baseline.
		spec description: 'Use ConfigurationOfOmniBrowser to load OB if not already installed'.
		spec repository: 'http://seaside.gemstone.com/ss/GLASSClient'.
		spec
			project: 'FFI' with: [
				spec
					className: 'ConfigurationOfFFI';
					versionString: '1.2';
					file: 'ConfigurationOfFFI';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'OB' with: [
				spec
					className: 'ConfigurationOfOmniBrowser';
					loads: #('Core' 'OB-Shout' );
					file: 'ConfigurationOfOmniBrowser';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: 'Core';
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			yourself.

		spec 
			package: 'OB-SUnitGUI' with: [
				spec repository: 'http://seaside.gemstone.com/ss/obsunit' ];
			package: 'GemTools-Client' with: [
				spec requires: #( 'FFI' 'OB-SUnitGUI' ) ];
			package: 'GemTools-Platform' with: [
				spec requires: #( 'GemTools-Client' ) ];
			yourself.

		spec group: 'default' with: #('OB-SUnitGUI' 'GemTools-Client' 'GemTools-Platform' ).

		spec for: #'OBNotPresent' do: [
			spec package: 'GemTools-Client' with: [
				spec requires: #( 'OB' ) ]].

		spec for: #'ShoutNotPresent' do: [
			spec package: 'GemTools-Client' with: [
				spec requires: #( 'Shout' ) ]]	].
	spec for: #pharo do: [
		spec
			project: 'ProfStef' with: [
				spec
					className: 'ConfigurationOfProfStef';
					versionString: '1.0-baseline';
					file: 'ConfigurationOfProfStef';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			yourself.
		spec
			package: 'GemTools-Client' with: [
				spec includes: #( 'GemTools-ProfStef' ) ];
			package: 'GemTools-ProfStef' with: [
				spec requires: #('ProfStef' 'GemTools-Client') ];
			yourself.
		].! !

!ConfigurationOfGemTools methodsFor: 'baselines' stamp: 'DaleHenrichs 2/26/2010 14:41'!
baseline10beta6: spec 
	<version: '1.0-beta.6-baseline'>
	
	spec for: #squeakCommon do: [
		spec blessing: #baseline.
		spec description: 'Use ConfigurationOfOmniBrowser to load OB if not already installed'.
		spec repository: 'http://seaside.gemstone.com/ss/GLASSClient'.
		spec
			project: 'FFI' with: [
				spec
					className: 'ConfigurationOfFFI';
					versionString: '1.2';
					file: 'ConfigurationOfFFI';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'OB' with: [
				spec
					className: 'ConfigurationOfOmniBrowser';
					loads: #('Core' 'OB-Shout' );
					file: 'ConfigurationOfOmniBrowser';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: 'Core';
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			yourself.

		spec 
			package: 'OB-SUnitGUI' with: [
				spec repository: 'http://seaside.gemstone.com/ss/obsunit' ];
			package: 'GemTools-Client' with: [
				spec requires: #( 'FFI' 'OB-SUnitGUI' ) ];
			package: 'GemTools-Platform' with: [
				spec requires: #( 'GemTools-Client' ) ];
			package: 'GemTools-Overrides';
			yourself.

		spec group: 'default' with: #('OB-SUnitGUI' 'GemTools-Client' 'GemTools-Platform' ).

		spec for: #'OBNotPresent' do: [
			spec package: 'GemTools-Client' with: [
				spec requires: #( 'OB' ) ]].

		spec for: #'ShoutNotPresent' do: [
			spec package: 'GemTools-Client' with: [
				spec requires: #( 'Shout' ) ]]	].
	spec for: #pharo do: [
		spec
			project: 'HelpSystem' with: [
				spec
					className: 'ConfigurationOfHelpSystem';
					versionString: '1.0-baseline';
					file: 'ConfigurationOfHelpSystem';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			yourself.
		spec
			package: 'GemTools-Client' with: [
				spec includes: #( 'GemTools-ProfStef' 'GemTools-Help') ];
			package: 'GemTools-ProfStef' ; "empty package at this point"
			package: 'GemTools-Help' with: [
				spec requires: #('HelpSystem' 'GemTools-Client') ];
			yourself.
		].! !

!ConfigurationOfGemTools methodsFor: 'accessing' stamp: 'dkh 1/11/2010 12:50'!
project

	| versionString projectAttributes |
	^ project ifNil: [
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		project := (Smalltalk at: #MetacelloMCProject) new.
		projectAttributes := #().
		Smalltalk at: #SystemVersion ifPresent: [:cl |
			versionString := cl current version.
			(versionString beginsWith: 'Pharo') 
				ifTrue: [
					(versionString beginsWith: 'Pharo0.1')
						ifFalse: [ projectAttributes := projectAttributes, #(#'pharo1.0Beta') ]]].
		Smalltalk at: #OBNode ifAbsent: [ projectAttributes := projectAttributes, #(#'OBNotPresent') ].
		Smalltalk at: #SHParserST80 ifAbsent: [ projectAttributes := projectAttributes, #(#'ShoutNotPresent') ].
		project projectAttributes:  projectAttributes.
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear]! !

!ConfigurationOfGemTools methodsFor: 'versions' stamp: 'dkh 10/15/2009 14:43'!
version10beta0: spec
	<version: '1.0-beta.0' imports: #('1.0-beta.0-baseline' )>

	spec for: #squeakCommon do: [
		spec blessing: #beta.
		spec description: 'GemTools client for Pharo/Squeak. Initial beta.'.
		spec 
			package: 'OB-SUnitGUI' with: 'OB-SUnitGUI-dkh.52';
			package: 'GemTools-Client' with: 'GemTools-Client.experimental-dkh.495';
			package: 'GemTools-Platform' with: 'GemTools-Platform.squeakCommon-dkh.2'.].
	spec for: #'pharo1.0Beta' do: [
		spec package: 'GemTools-Platform' with: 'GemTools-Platform.pharo10beta-dkh.4'.].! !

!ConfigurationOfGemTools methodsFor: 'versions' stamp: 'dkh 11/3/2009 14:03'!
version10beta1: spec
	<version: '1.0-beta.1' imports: #('1.0-beta.0-baseline' )>

	spec for: #squeakCommon do: [
		spec blessing: #beta.
		spec description: '- Convert to using ConfigurationOfGemTools
- nicer info dialog when Undefined symbols and unsent messages are clean
- support for 3.0 GciErrSType
- change restore from backup done message ... do not prompt to start Seaside gems if Seaside is not installed
- replace dialogs that are calling "ifNotEmpty:" with: "isEmptyOrNil" (from Gerhard)
- autoAbort _before_ commands is now optional (off by default)
'.
		spec 
			package: 'OB-SUnitGUI' with: 'OB-SUnitGUI-dkh.52';
			package: 'GemTools-Client' with: 'GemTools-Client-dkh.504';
			package: 'GemTools-Platform' with: 'GemTools-Platform.squeakCommon-dkh.3'.].
	spec for: #'pharo1.0Beta' do: [
		spec package: 'GemTools-Platform' with: 'GemTools-Platform.pharo10beta-dkh.5'.].! !

!ConfigurationOfGemTools methodsFor: 'versions' stamp: 'dkh 12/2/2009 14:15'!
version10beta2: spec
	<version: '1.0-beta.2' imports: #('1.0-beta.0-baseline' )>

	spec for: #squeakCommon do: [
		spec blessing: #beta.
		spec description: '- fix update client logic to use #lastMetacelloVersionLoad
- change annotation pane and make more room for useful info
- inspect undefined and inspect sent but not implemented menu items available only when available
- clean up preferences problems when not present
- Admin>>Seaside submen available only when Seaside2.8 installed
- improve session window label (include the session name) when working with multiple stones
'.
		spec 
			package: 'OB-SUnitGUI' with: 'OB-SUnitGUI-dkh.52';
			package: 'GemTools-Client' with: 'GemTools-Client-dkh.509';
			package: 'GemTools-Platform' with: 'GemTools-Platform.squeakCommon-dkh.3'.].
	spec for: #'pharo1.0Beta' do: [
		spec package: 'GemTools-Platform' with: 'GemTools-Platform.pharo10beta-dkh.5'.].! !

!ConfigurationOfGemTools methodsFor: 'versions' stamp: 'DaleHenrichs 1/25/2010 09:46'!
version10beta3: spec
	<version: '1.0-beta.3' imports: #('1.0-beta.3-baseline' )>

	spec for: #common do: [
		spec blessing: #beta.
		spec description: '- improve ''Show Object log'' output format
- add ''List backup files'' command
- add some missing icon definitions for Squeak
- load OB/Shout if not present
- ProfStef tutorials (Pharo only)
'.
		spec author: 'DaleHenrichs'.
		spec timestamp: '1/25/2010 09:46'.
].
	spec for: #squeakCommon do: [
		spec 
			project: 'Shout' with: '1.0';
			project: 'OB' with: '1.1'.
		spec 
			package: 'OB-SUnitGUI' with: 'OB-SUnitGUI-dkh.52';
			package: 'GemTools-Client' with: 'GemTools-Client-DaleHenrichs.513';
			package: 'GemTools-Platform' with: 'GemTools-Platform.squeakCommon-dkh.4'.].
	spec for: #pharo do: [
		spec project: 'ProfStef' with: '1.0'.
		spec package: 'GemTools-ProfStef' with: 'GemTools-ProfStef-DaleHenrichs.9'.].
	spec for: #'pharo1.0Beta' do: [
		spec package: 'GemTools-Platform' with: 'GemTools-Platform.pharo10beta-dkh.5'.].! !

!ConfigurationOfGemTools methodsFor: 'versions' stamp: 'JamesFoster 2/2/2010 14:16'!
version10beta4: spec
	<version: '1.0-beta.4' imports: #('1.0-beta.3-baseline' )>

	spec for: #common do: [
		spec blessing: #beta.
		spec description: '- Rename GCI library for Squeak 3.11.3-2135
'.
		spec author: 'JamesFoster'.
		spec timestamp: '2/2/2010 14:14'.
].
	spec for: #squeakCommon do: [
		spec 
			project: 'Shout' with: '1.0';
			project: 'OB' with: '1.1'.
		spec 
			package: 'OB-SUnitGUI' with: 'OB-SUnitGUI-dkh.52';
			package: 'GemTools-Client' with: 'GemTools-Client-JamesFoster.514';
			package: 'GemTools-Platform' with: 'GemTools-Platform.squeakCommon-dkh.4'.].
	spec for: #pharo do: [
		spec project: 'ProfStef' with: '1.0'.
		spec package: 'GemTools-ProfStef' with: 'GemTools-ProfStef-DaleHenrichs.9'.].
	spec for: #'pharo1.0Beta' do: [
		spec package: 'GemTools-Platform' with: 'GemTools-Platform.pharo10beta-dkh.5'.].! !

!ConfigurationOfGemTools methodsFor: 'versions' stamp: 'DaleHenrichs 2/8/2010 15:33'!
version10beta5: spec
	<version: '1.0-beta.5' imports: #('1.0-beta.3-baseline' )>

	spec for: #common do: [
		spec blessing: #beta.
		spec description: '- fix bug in the new GCI library code ... linux-gnu is also a valid os name
'.
		spec author: 'DaleHenrichs'.
		spec timestamp: '2/8/2010 15:33'.
].
	spec for: #squeakCommon do: [
		spec 
			project: 'Shout' with: '1.0';
			project: 'OB' with: '1.1'.
		spec 
			package: 'OB-SUnitGUI' with: 'OB-SUnitGUI-dkh.52';
			package: 'GemTools-Client' with: 'GemTools-Client-DaleHenrichs.515';
			package: 'GemTools-Platform' with: 'GemTools-Platform.squeakCommon-dkh.4'.].
	spec for: #pharo do: [
		spec project: 'ProfStef' with: '1.0'.
		spec package: 'GemTools-ProfStef' with: 'GemTools-ProfStef-DaleHenrichs.9'.].
	spec for: #'pharo1.0Beta' do: [
		spec package: 'GemTools-Platform' with: 'GemTools-Platform.pharo10beta-dkh.5'.].! !

!ConfigurationOfGemTools methodsFor: 'versions' stamp: 'DaleHenrichs 2/26/2010 14:44'!
version10beta6: spec
	<version: '1.0-beta.6' imports: #('1.0-beta.6-baseline' )>

	spec for: #common do: [
		spec blessing: #development.
		spec description: '- updated How To... with upgrade instructions to 1.0-beta.7
- fixed highlighting for class definition/creation template
- enabled syntax highlighting in workspaces
- double click includes leading $_. In package GemTools-Overrides that is not loaded by default, because it stomps on a method in Character.
- GsOBColumnPanel>>currentNode sends #currentNode to server-side, fixing a couple of ancient bugs
- reset GLASS version after doing a Server update
- exclude #baseline versions from update glass client version list
- add proportional splitters to inspectors (resize panes vertically)
- Use Help System instead of ProfStef
- fix Issue 54: http://code.google.com/p/glassdb/issues/detail?id=54 "Typos and unclear instructions in GemTools ProfStef tutorial"
'.
		spec author: 'DaleHenrichs'.
		spec timestamp: '2/26/2010 14:44'.
].
	spec for: #squeakCommon do: [
		spec 
			project: 'Shout' with: '1.0';
			project: 'OB' with: '1.1'.
		spec 
			package: 'OB-SUnitGUI' with: 'OB-SUnitGUI-dkh.52';
			package: 'GemTools-Client' with: 'GemTools-Client-DaleHenrichs.522';
			package: 'GemTools-Overrides' with: 'GemTools-Overrides-DaleHenrichs.1';
			package: 'GemTools-Platform' with: 'GemTools-Platform.squeakCommon-dkh.4'.].
	spec for: #pharo do: [
		spec project: 'HelpSystem' with: '1.0'.
		spec 
			package: 'GemTools-Help' with: 'GemTools-Help-DaleHenrichs.10';
			package: 'GemTools-ProfStef' with: 'GemTools-ProfStef-DaleHenrichs.13'.].
	spec for: #'pharo1.0Beta' do: [
		spec package: 'GemTools-Platform' with: 'GemTools-Platform.pharo10beta-dkh.5'.].! !
